︠b7f3b3d4-2f78-44a7-8426-1c66c0766e6cs︠
#----------------------------------------------------------------
# Sample code for UEET2533 Information Theory and Coding
# by Chong Zan Kai
# Email chongzk@utar.edu.my
# Universiti Tunku Abdul Rahman, Malaysia.
#
# We demonstrate how an image look like after passing a BSC channel.
#
# Last modified on 9-Jan-2015.
#----------------------------------------------------------------

#----------------------------------------------------------------
# Functions to convert image to matrix and vice versa.
#----------------------------------------------------------------
import matplotlib.pyplot as plt
import matplotlib.image as mpimg
import numpy as np

#
# Convert image 2darray to GF2 matrix.
#
def img_arr_to_matrix(img_2darr):
    #img_2darr = mpimg.imread(bmp_file)
    img_2dlist = []
    #
    # Convert to 0 and 1 first.
    for p4_arr in img_2darr:
        a_list = [int(p[0]>0) for p in p4_arr]
        img_2dlist.append(a_list)
    #
    img_mat = matrix(GF(2), img_2dlist)
    return img_mat

#
# Convert GF2 matrix back to image 2darr.
#
def img_matrix_to_arr(img_mat):
    img_2darr = []
    for row in img_mat.rows():
        pixel_list = [ np.uint8([int(r) * 255, int(r) * 255, int(r) * 255, 255 ]) for r in row]
        img_2darr.append(pixel_list)
    return np.array(img_2darr)



#
# Introduce noise to the message in BSC channel.
#
def bsc_channel(msg_mat, p_flip):
    new_msg_mat = copy (msg_mat)
    total_row, total_col = new_msg_mat.dimensions()
    for r in range(total_row):
        for c in range(total_col):
            rand_val = random()
            if rand_val <= p_flip:
                new_msg_mat[r, c] += 1

    return new_msg_mat


#----------------------------------------------------------------

#----------------------------------------------------------------
# Main
#----------------------------------------------------------------

#----------------------------------------------------------------
# Main
#----------------------------------------------------------------

p_flip = 0.1 # Noise probability
sample_file = 'sample01.bmp'



#
# Present the orignial image
#
# Read the image file as array
img_arr = mpimg.imread(sample_file)


# Display the image
print 'Original image:'
plt.imshow(img_arr)
print

# Convert image array to GF2 matrix
img_mat = img_arr_to_matrix (img_arr)
print

#
# Introduce noise to the image
#
recv_img_mat = bsc_channel(img_mat, p_flip)


#
# Present the received image
#
# Convert to arr first
recv_img_arr = img_matrix_to_arr (recv_img_mat)

# Display image
print 'Received image after BSC channel:'
plt.imshow(recv_img_arr)
︡76b45e89-ee1a-4fda-9c65-2d9628ffe967︡{"stdout":"Original image:\n"}︡{"once":false,"file":{"show":true,"uuid":"fe7056be-90d4-4ba2-b297-2a83aa14f6d6","filename":"/projects/aa4bf021-2480-4a83-b5dd-903f497a8515/.sage/temp/compute20dc0/18153/tmp_QqgtAp.png"}}︡{"stdout":"\n"}︡{"stdout":"\n"}︡{"stdout":"Received image after BSC channel:\n"}︡{"once":false,"file":{"show":true,"uuid":"777f1302-f631-46fa-a4c8-ef75efc38e86","filename":"/projects/aa4bf021-2480-4a83-b5dd-903f497a8515/.sage/temp/compute20dc0/18153/tmp_HNI0xK.png"}}︡
︠79c2f806-9e97-4023-b87e-7b37098ceb48︠
︡428f106e-fabd-485a-9c7f-d792ed187edc︡
︠71730684-c4da-415d-b33f-2aae930135a9︠









